<?php
///////////////////////////////////////////////////////////////////////////
/*
	ver.	0.9.0
		02.March.2005
	
	This is a addon for phpBB
	"Free Integrated Picture Search Add-On Mod for phpBB 2.x powered by Yahoo"
	
	If you are not a phpBB webmaster
	then this file is probably useless for you
	
	Please read "readme.txt" for 
		* installation procedures
		* explanations
		* functioning example links in practice
*/

///////////////////////////////////////////////////////////////////////////

$appid = 'YahooDemo'; // <- the original value for testing purposes
$appid = ''; // INSERT YOUR OWN ID HERE
/*
	EDIT the above line!! 
	You need to apply for an ID at 
		http://developer.yahoo.net/
	I got my own ID within seconds.
*/

/////////////////////////////////////////////
// Don't edit anything further
/////////////////////////////////////////////

/////////////////////////
// Typical PHPBB stuff
/////////////////////////

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

// Get Language file
$lang_file = $phpbb_root_path.'language/lang_'.$board_config['default_lang'].'/lang_integrated_pic_search.'.$phpEx;
if (!@file_exists($lang_file)) // load English version if there is no translation to current language
	{
	$lang_file = $phpbb_root_path.'language/lang_english/lang_integrated_pic_search.'.$phpEx;
	}
include($lang_file);

// Output Page head
$_REQUEST['service'] = ($_REQUEST['service'] == 'image') || ($_REQUEST['service'] == 'video') ? $_REQUEST['service'] : 'image'; // Define value if not defined
$service2 = ($_REQUEST['service'] == 'image') ? 'photo' : 'movie'; // better for Google. "Movie gallery" (not "Movies") and "Photo gallery" (not "Photos gallery") are searched more often than "image" and "video"

$page_title = ucwords(($_REQUEST['query'] ? htmlspecialchars($_REQUEST['query'],ENT_QUOTES).' ' : '').$service2.' '.$lang['intpicsearch_gallery']) ; // define <title></title>
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
	'ipstemplate' => 'integrated_pic_search'.($_REQUEST['templatenumber']).'.tpl',
	'ipsquerytemplate' => 'integrated_pic_search_query.tpl'
	)
	);
	
@include_once('integrated_pic_search_break_codes'.($_REQUEST['templatenumber']).'.'.$phpEx);

	
///////////////////////////////////
// START OF THE PIC SEARCH SCRIPT
///////////////////////////////////

$parameters = 'query,zip,start,adult_ok,results,type,service,templatenumber'; 

$template->assign_vars(array( // General variables for the template
	'FILENAME' => basename(__FILE__),
	'L_POWEREDBY' => $lang['intpicsearch_yahoo_powered'],
	'L_FROM' => $lang['intpicsearch_from'],
	'L_TO' => $lang['intpicsearch_to'],
	'L_FOUND' => $lang['intpicsearch_found'],
	'L_NEXT' => $lang['intpicsearch_next'],
	'L_PREVIOUS' => $lang['intpicsearch_previous'],
	'L_SHOWING' => $lang['intpicsearch_showing'],
	'L_SHOW' => $lang['intpicsearch_show'],
	'L_OUT_OF' => $lang['intpicsearch_outof'],
	'L_SEARCH' => $lang['intpicsearch_search'],
	'PAGETITLE' => $lang['intpicsearch_pagetitle'],
	'L_IMAGES' => $lang['intpicsearch_images'],
	'L_VIDEOS' => $lang['intpicsearch_videos'],
	'L_SUBMIT' => $lang['intpicsearch_submit'],
	'L_AND' => $lang['intpicsearch_and'],
	'L_VIDEOANDIMAGESEARCH' => $lang['intpicsearch_videoandimagesearch'],
	'L_QUERY_QUESTION' => $_REQUEST['query'] ? htmlspecialchars($_REQUEST['query'],ENT_QUOTES) : $lang['intpicsearch_query_question'],
	'L_GOOGLE_IMAGE_SEARCH' => $_REQUEST['query'] ? sprintf($lang['intpicsearch_google_image_search'],htmlspecialchars($_REQUEST['query'],ENT_QUOTES)) : '',
	'L_NOTHING_FOUND' => $lang['intpicsearch_nothingfound'],
	'L_GALLERY' => $lang['intpicsearch_gallery'],
	'TEMPLATENUMBER' => $_REQUEST['templatenumber'],
	
	
	'SELECTEDIMAGE' => $_REQUEST['service'] == 'image' ? ' selected ' : '',
	'SELECTEDVIDEO' => $_REQUEST['service'] == 'video' ? ' selected ' : '',
	
	'INCLUDE' => sprintf($lang['intpicsearch_include'],$service2.'s'),
	
	'GOOGLE_IMAGE_SEARCH_URL' => $_REQUEST['query'] ? 'http://images.google.com/images?filter=0&q='.rawurlencode($_REQUEST['query']) : '',
	
	'DELETONFOCUS' => $_REQUEST['query'] ? '' : 'onFocus="this.value=\'\'"',
	'QUERY' => htmlspecialchars($_REQUEST['query'],ENT_QUOTES),
	'QUERYUCWORDS' => htmlspecialchars(ucwords($_REQUEST['query']),ENT_QUOTES),
	'SERVICE' => $service2,
	'SERVICES' => $service2.'s'
	));


if (empty($_REQUEST['query'])) // Error: The user started a search without a query
	{
	$template->assign_vars(array( // General variables for the template
		'FILENAME' => basename(__FILE__)
		));
	$template->pparse('ipsquerytemplate');
	include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
	exit;
	}

function xml_to_result($dom) // XML -> $res[] = Convert XML into an PHP array
	{
	$root = $dom->document_element();
	$res['totalResultsAvailable'] = $root->get_attribute('totalResultsAvailable');
	$res['totalResultsReturned'] = $root->get_attribute('totalResultsReturned');
	$res['firstResultPosition'] = $root->get_attribute('firstResultPosition');
	
	$node = $root->first_child();
	$i = 0;
	while ($node)
		{
		switch($node->tagname)
			{
			case 'Result':
	      			$subnode = $node->first_child();
				while ($subnode)
					{
					$subnodes = $subnode->child_nodes();
					if (!empty($subnodes))
						{
						foreach($subnodes as $k=>$n)
							{
							if (empty($n->tagname))
								{
								$res[$i][$subnode->tagname] = trim($n->get_content());
								}
	          					else
	          						{
	          						$res[$i][$subnode->tagname][$n->tagname]=trim($n->get_content());
	          						}
	        					}
	        				}
	        			$subnode = $subnode->next_sibling();
	      				}
	      			break;
	    		default:
	      			$res[$node->tagname] = trim($node->get_content());
	      			$i--;
	      			break;
	  		}
		$i++;
		$node = $node->next_sibling();
		}
	return $res;
	}

function appendqueries() // Create the Query string for the URL, something like e.g. "?query=xxx&type=images&appid="
	{
	global $parameters;
	$q = '';
	foreach (explode(',',$parameters) as $parameter)
		{
		if (!empty($parameter) && !empty($_REQUEST[$parameter]))
			{
			$q .= ($q ? '&' : '?').$parameter.'='.rawurlencode($_REQUEST[$parameter]); // No &amp; here
			}
		}
	return $q;
	}
	
if (empty($appid)) // Error: The user started a search without a query
	{
	message_die(GENERAL_ERROR,'Before you start, you need to go to <a href="http://developer.yahoo.net/">http://developer.yahoo.net/</a> to get your own Application ID (that\'s a matter of seconds. After you have your own ID, edit the file "integrated_pic_search.php" and insert it there.');
	}

// These are the different types of searches that Yahoo supports
// So far only the image search makes, since this script searches for images only
$services['image'] =	'http://api.search.yahoo.com/ImageSearchService/V1/imageSearch';
$services['local'] =	'http://api.local.yahoo.com/LocalSearchService/V1/localSearch';
$services['news'] =	'http://api.search.yahoo.com/NewsSearchService/V1/newsSearch';
$services['video'] =	'http://api.search.yahoo.com/VideoSearchService/V1/videoSearch';
$services['web'] =	'http://api.search.yahoo.com/WebSearchService/V1/webSearch';

$_REQUEST['results'] = $_REQUEST['results'] ? $_REQUEST['results'] : '20'; // Define value if not defined
$_REQUEST['results'] = $_REQUEST['results'] > 50 ?  50 : $_REQUEST['results']; // Yahoo allows only up to 50 results

// Get the data from Yahoo
// echo '<br />'.$services[$_REQUEST['service']].appendqueries().'&appid='.$appid).'<br />'; // For debugging purposes

$xml = @file_get_contents($services[$_REQUEST['service']].appendqueries().'&appid='.$appid); 
if (!$dom = @domxml_open_mem($xml,DOMXML_LOAD_PARSING,$error)) // Everything OK?
	{
	/* Only for debugging
	foreach ($error as $errorline) 
		{
		echo $errorline['errormessage']."<br />\n";
		echo " Node  : " . $errorline['nodename'] . "<br />\n";
		echo " Line  : " . $errorline['line'] . "<br />\n";
		echo " Column : " . $errorline['col'] . "<br />\n";
		}
	/**/
	message_die(GENERAL_ERROR,'Yahoo XML parse error');
	}

if (!$res = xml_to_result($dom)) // Parse the XML -> $res[]
	{
	message_die(GENERAL_ERROR,'Nothing found');
	}
	
// The data is now in $res[$i]['xxxx'] where xxxx 
// is one of the values described at 
// http://developer.yahoo.net/image/V1/imageSearch.html
// or use the following php code to study the format
/*
echo '<pre>';
print_r($res);
echo '</pre>';
/**/

// Cycle thru the resulting search and set each variable for the phpBB template
$baseresolution = $_REQUEST['service'] == 'video' ? $baseresolutionvideo : $baseresolutionimage;
$goodwebsites = array();
for ($i=0; $i < $res['totalResultsReturned']; $i++)
	{
	$homepage = preg_replace('#(.*?)(:\/\/)(www[.])?([-_.0-9a-zA-Z]+)(.*)#','\\4',$res[$i]['RefererUrl']); // Why "_"? Because this is valid: http://x_y.yahoo.com
	if (preg_match('#([.]org|[.]gov|[.]ca)[\\\\\/]#',$res[$i]['RefererUrl'])) // Website has probably high pagerank
		{
		$website = strtolower(preg_replace('#(.*?)(:\/\/)(www[.])?([-_.0-9a-zA-Z]+)(.*)#','\\1\\2\\3\\4',$res[$i]['RefererUrl']));
		$fullurl = '<a target="_blank" href="'.$website.'">'.$homepage.'</a>';
		if (!in_array($fullurl,$goodwebsites))
			{
			$goodwebsites[] = $fullurl;
			}
		}
	
	$resolution = $res[$i]['Width']*$res[$i]['Height'];
	$multiplicator = max(0.1,min(3,$resolution/$baseresolution)); // Everything above 1024*768 becomes > 1. Everything below becomes < 1
	
	// Calculate thumbnail sizes according to the pic size (= the bigger the pic the bigger the thumbnail)
	$pixels = max($res[$i]['Thumbnail']['Width'],$res[$i]['Thumbnail']['Height']);
	$adjustpixels = 135/$pixels;
	$widthproportional = $res[$i]['Thumbnail']['Width']*$adjustpixels; // resize the thumb to exactly 100x or x100
	$heightproportional = $res[$i]['Thumbnail']['Height']*$adjustpixels;
	
	// Calculate thumbnailsize if the Width and the height can be maximal XXX pixels (as defined with $exactpixels) = Either the width is XXX pixels OR the height BUT none is bigger than XXX pixels
	$adjustpixels = $exactpixels/$pixels;
	$widthmax150 = $res[$i]['Thumbnail']['Width']*$adjustpixels;
	$heightmax150 = $res[$i]['Thumbnail']['Height']*$adjustpixels;
	
	// Calculate thumbnail sizes if the width shall ALWAYS be XXX pixels (as defined with $exactpixels)
	$pixels = $res[$i]['Thumbnail']['Width'];
	$adjustpixels = $exactpixels/$pixels;
	$widthalwayssame = $res[$i]['Thumbnail']['Width']*$adjustpixels;
	$heightadjusted = $res[$i]['Thumbnail']['Height']*$adjustpixels;
	
	// Calculate thumbnail sizes if the height shall ALWAYS be XXX pixels (as defined with $exactpixels)
	$pixels = $res[$i]['Thumbnail']['Height'];
	$adjustpixels = $exactpixels/$pixels;
	$heightalwayssame = $res[$i]['Thumbnail']['Height']*$adjustpixels;
	$widthadjusted = $res[$i]['Thumbnail']['Width']*$adjustpixels;
	
	$startofrowhtmlnow = '';
	$endofrowhtmlnow = '';
	
	if ($breakevery)
		{
		$iteminrow = ($i+1) % $breakevery;
		
		if (($i+1-1) % $breakevery == 0) // Start of new row
			{
			$startofrowhtmlnow = $startofrowhtml;
			}
		
		if (($iteminrow == 0) || (($i+1) == $res['totalResultsReturned']))  // End of row OR last output of the last row
			{
			if ($iteminrow == 0) // End of full row
				{
				$endofrowhtmlnow = $endofrowhtml;
				}
			else // Complete end of output (= last item of the last row), but row has less items then the other rows -> Fill up
				{
				$endofrowhtmlnow = str_repeat($emptyhtml,($breakevery-$iteminrow)).$endofrowhtml;
				}
			}
		}
	
	$template->assign_block_vars('eachpic', array( // Variables within the <--- BEGIN/END eachpic ---> part
		'THUMBIMGSRC' => $res[$i]['Thumbnail']['Url'],
		'CLICKURL' =>  $res[$i]['ClickUrl'],

		'THUMBWIDTH' => $res[$i]['Thumbnail']['Width'],
		'THUMBHEIGHT' => $res[$i]['Thumbnail']['Height'],

		'THUMBWIDTHPROPORTIONAL' => intval(sqrt($multiplicator)*$widthproportional),
		'THUMBHEIGHTPROPORTIONAL' => intval(sqrt($multiplicator)*$heightproportional),

		'THUMBWIDTHMAX' => $widthmax150,
		'THUMBHEIGHTMAX' => $heightmax150,

		'THUMBWIDTHALWAYSSAME' => $widthalwayssame,
		'THUMBHEIGHTADJUSTED' => $heightadjusted,

		'THUMBHEIGHTALWAYSSAME' => $heightalwayssame,
		'THUMBWIDTHADJUSTED' => $widthadjusted,
		
		'PICSIZERATIO' => number_format($resolution/$baseresolution*100,0,'.','\''),
		
		'PICWIDTH' => $res[$i]['Width'],
		'PICHEIGHT' => $res[$i]['Height'],
		'PICTITLE' => htmlspecialchars($res[$i]['Title'],ENT_QUOTES),
		'PICFORMAT' => $res[$i]['FileFormat'],
		'PICFORMATIFNOTJPG' => $res[$i]['FileFormat'] == 'jpeg' ? '' : $res[$i]['FileFormat'],
		'BRIFNOTJPG' => $res[$i]['FileFormat'] == 'jpeg' ? '' : '<br />',
		'DISPLAYNONEIFJPG' => $res[$i]['FileFormat'] == 'jpeg' ? 'display:none;' : '',
		'PICKILOBYTE' => htmlspecialchars(number_format($res[$i]['FileSize']/1024,1,'.','\''),ENT_QUOTES),
		'PICSUMMARY' => htmlspecialchars($res[$i]['Summary'],ENT_QUOTES),
		'PICBYTE' => htmlspecialchars(number_format($res[$i]['FileSize'],0,'.','\'').'KB',ENT_QUOTES),
		'AVATARPATH' => $path.$row['user_avatar'],
		'THUMBNUMBER' => $i+1,
		'PAGEWITHPIC' => $res[$i]['RefererUrl'],
		'PICHOMEPAGE' => $homepage,
		'PICHOMEPAGEURL' => preg_replace('#(.*?)(:\/\/)(www[.])?([-_.0-9a-zA-Z]+)(.*)#','\\1\\2\\3\\4',$res[$i]['RefererUrl']),
		'ROW_CLASS' => !($i % 2) ? $theme['td_class1'] : $theme['td_class2'],
		'STARTOFROW' => $startofrowhtmlnow,
		'ENDOFROW' => $endofrowhtmlnow
		)
		);
	}
	
$first = $res['firstResultPosition'];
$last = $first+$res['totalResultsReturned']-1;
if (($res['totalResultsReturned'] < $_REQUEST['results']) && ($last < $res['totalResultsAvailable'])) // Less returned than possible
	{
	$_REQUEST['results'] = $res['totalResultsReturned'];
	}

// Create "Previous" Link
if ($first > 1)
	{
	$_REQUEST['start'] = max(1,$first-$_REQUEST['results']);
	$previousurl = basename(__FILE__).appendqueries();
	}

// Create "Next" Link
if ($last < $res['totalResultsAvailable']) 
	{
	$_REQUEST['start'] = $last+1;
	$nexturl = basename(__FILE__).appendqueries();
	}
	

// Define some more variables for the phpBB template and we are done
$template->assign_vars(array( // General variables for the template
	'TOTALFOUND' => htmlspecialchars(number_format($res['totalResultsAvailable'],0,'.','\''),ENT_QUOTES),
	'TOTALDISPLAYED' => $res['totalResultsReturned'],
	'AMOUNTOFNEXT' => min($res['totalResultsAvailable']-($last+1),$_REQUEST['results']),
	'AMOUNTOFPREVIOUS' => min($first-1,$_REQUEST['results']),
	'STARTPOSITION' => $first,
	'ENDPOSITION' => $last,
	'DISPLAYNONEIFNOPREVIOUS' => $previousurl ? '' : 'display:none;',
	'DISPLAYNONEIFNONEXT' => $nexturl ? '' : 'display:none;',
	'NEXTSTARTPOSITION' => min($last+1,$res['totalResultsAvailable']),
	'NEXTENDPOSITION' => min($res['totalResultsAvailable'],$last+1+$_REQUEST['results']-1),
	'PREVIOUSSTARTPOSITION' => max(1,$first-$_REQUEST['results']),
	'PREVIOUSENDPOSITION' => max(max($first-1,$_REQUEST['results']),1),
	'RESULTSNUM' => $_REQUEST['results'],
	'NEXTURL' => $nexturl,
	'PREVIOUSURL' => $previousurl,
	'ALLGOODWEBSITES' => $first == 1 ? implode(', ',$goodwebsites) : '',
	'DISPLAYNONEINCLUDED' => (($first > 1) || (!$goodwebsites)) ? ' display:none; ' : '',
	'DISPLAYNONIFSOMETHINGFOUND' => $res['totalResultsAvailable'] > 0 ? ' display:none; ' : '',
	'DISPLAYNONIFNOTHINGFOUND' => $res['totalResultsAvailable'] == 0 ? ' display:none; ' : '',
	'L_RESULTS' => $lang['intpicsearch_results'].($res['totalResultsAvailable'] != 1 ? 's' : ''),
	)
	);

///////////////////////////////////////////////////////////
// Typical phpBB stuff to finish the output. Finished!
///////////////////////////////////////////////////////////

$template->pparse('ipstemplate');
$template->pparse('ipsquerytemplate');
// This copyright note MUST stay
echo '<br /><br /><div class="gensmall" style="text-align:right; width:100%"><a href="http://www.1-4a.com">Free Integrated Picture Search Add-on Mod for phpBB by 1-4a.com</a></div>';
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
	
?>
